require 'tk'
#Root Window#############################
root = TkRoot.new{title "Ruby Editor"}
root['geometry'] = '1540x700+1+1'
## 2 Buttons : to run file and run code #################
$button1 = TkButton.new(root){
text "Run File"
borderwidth 4
font TkFont.new('times 14 bold')
background  "green"
relief    "groove"
command(proc{runfile})

def runfile
  if $filename != nil
    $out = %x[ruby "#$filename" 2>&1]
    $win2.delete(1.0, 'end')
    $win2.insert('end', "#$out")
  else 
   $win2.insert('end', "No File Selected")
  end
end
}

$button2 = TkButton.new(root){
text "Run Code"
borderwidth 4
font TkFont.new('times 14 bold')
background  "green"
relief    "groove"
command(proc{runcode})

def runcode
    theCode = $win1.get("1.0", 'end')
    File.write("tmp.rb", theCode)
    $out = %x[ruby "tmp.rb" 2>&1]
    $win2.delete(1.0, 'end')
    $win2.insert('end', "#$out") 
end
}

#________MENU________________________________________________
TkOption.add '*tearOff', 0
$filename =TkVariable.new
$newfilename =TkVariable.new
#______________Methods of the Menu ______________
newfile = Proc.new{$win1.delete(1.0, 'end')}
clearWin2 = Proc.new{$win2.delete(1.0, 'end')}
#________________________
openfile = Proc.new{
$filename = Tk::getOpenFile()
$content = File.read($filename)
$win1.delete(1.0, 'end')
$win1.insert('end', $content)
}
#___________________________________
closefile = Proc.new{$win1.delete(1.0, 'end')}
#____________________________________
savefile = Proc.new{
thetext = $win1.get("1.0", 'end')
File.write($filename, thetext)
}
#____________________________________
savefileas = Proc.new{
thetext = $win1.get("1.0", 'end')
$newfilename = Tk::getSaveFile('filetypes' => [["All Files", "."], ["Text Files", ".txt"]])
File.write($newfilename, thetext)
}
#____________________________________
exitapp = Proc.new{exit}
help = Proc.new{help_win}
#_______ HELP MENU _____________________
def help_win
  begin
	$win.destroy
  rescue
  end
  $win = TkToplevel.new{title "Help Window"}
  TkLabel.new($win){
    text "This Ruby Editor allows you to:
  1. Open a saved script from folder through a dialogbox(Win1 Menu)
  2. Type your own new script and Save it (Save & Saveas in Win1 Menu)
  3. Clear Win1 screen for a new script (New or Close from Win1 Menu)
  4. Output from execution of code appears in Win2
  5. You can clear Win2 from Win2 Menu (clear)
  6. You may save the output of the script in a separate file (SaveAs in Win2 Menu)
  The green button run the script and send output to Win2.
  If you click the green button before selection of a script, a fatal error may occur.
  "
  borderwidth 5
  font TkFont.new('times 16 bold')
  background  "yellow"
  relief    "groove" 
  justify  "left"  
 }.grid('row' => 0, 'column' => 0)
  TkButton.new($win) {
	text "OK"
	command "$win.destroy"
  }.grid('row' => 1, 'column' => 0)
end
###################### Menu Structure ###################
win1_menu = TkMenu.new(root)
win2_menu = TkMenu.new(root)
helpMenu = TkMenu.new(root)
#______________________________
win1_menu.add('command',
              'label'     => "New...",
              'command'   => newfile,
              'underline' => 0)
win1_menu.add('command',
              'label'     => "Open...",
              'command'   => openfile,
              'underline' => 0)
win1_menu.add('command',
              'label'     => 'Close',
              'command'   => closefile,
              'underline' => 0)
win1_menu.add('separator')
win1_menu.add('command',
              'label'     => "Save",
              'command'   => savefile,
              'underline' => 0)
win1_menu.add('command',
              'label'     => "Save As...",
              'command'   => savefileas,
              'underline' => 5)
win1_menu.add('separator')
win1_menu.add('command',
              'label'     => "Exit",
              'command'   => exitapp,
              'underline' => 3)
helpMenu.add('command',
              'label'   => "Help",
              'command' => help,
              'underline' => 3)
#_________________________________________
win2_menu.add('command',
              'label'     => "Clear...",
              'command'   => clearWin2,
              'underline' => 0)
win2_menu.add('command',
              'label'     => "Save As...",
              'command'   => savefileas,
              'underline' => 5)

menu_bar = TkMenu.new
menu_bar.add('cascade',
             'menu'  => win1_menu,
             'label' => "Win1")
menu_bar.add('cascade',
             'menu'  => win2_menu,
             'label' => "Win2")
menu_bar.add('cascade',
             'menu' => helpMenu,
             'label' => "Help")

root.menu(menu_bar)
#__________________2 TEXT WINDOWS  _______________________________
## Win1 for Code and Win2 for output ###########################
$win1 = TkText.new(root) do
  width 82
  height 9
  background "black"
  foreground  "white"
  font TkFont.new('tahoma 16 normal')
  wrap 'word'
  insertbackground "yellow"
  insertwidth 3
  cursor  "hand2"
end

 $win2 = TkText.new(root) do
  width 82
  height 9
  background "black"
  foreground  "white"
  font TkFont.new('tahoma 16 normal')
  wrap 'word'
  insertbackground "yellow"
  insertwidth 3
  cursor  "hand2"
end
 
#___________ SCROLLBARS of WIN2 and WIN2 _____________________
$scrollbar1 = TkScrollbar.new(root){command proc{|*args| $win1.yview(*args)}
}
$win1.yscrollcommand(proc{|first, last| $scrollbar1.set(first, last)})

$scrollbar2 = TkScrollbar.new(root){command proc{|*args| $win2.yview(*args)}
}
$win2.yscrollcommand(proc{|first, last| $scrollbar2.set(first, last)})
#________________ GEOMETRY _____________________________
$win1.grid('row' => 0, 'column' => 0)
$win2.grid('row' => 1, 'column' => 0)
$button1.grid('row' =>3, 'column' => 0, 'sticky' => 'NW')
$button2.grid('row' =>3, 'column' => 0, 'sticky' => 'NE')
$scrollbar1.grid('row' => 0, 'column' => 1, 'sticky' => 'NS')
$scrollbar2.grid('row' => 1, 'column' => 1, 'sticky' => 'NS')
######### Show GUI ###############################
Tk.mainloop
######END OF SCRIPT #######